Queue a confirmed manual donor merge
Consumes a current actor-owned review after confirming same-person identity and a trimmed 10–2,000 character reason. Rechecks permissions, profile/dependency snapshot and stewardship impact before admitting exactly one queued merge. Same review and identical command recover the original batch; changed, expired or stale reviews return 409. Dependencies can return 422 blockers. Worker execution rechecks authority and snapshot before merging; HTTP 202 confirms admission, not completion.
curl --request POST \
--url https://api.gratona.com/v1/admin/donors/duplicates/manual-merge \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"review_id": "550e8400-e29b-41d4-a716-446655440000",
"confirmed_same_person": true,
"reason": "Verified duplicate donor records.",
"field_choices": {
"username": "primary",
"email": "primary",
"type": "primary",
"organization_name": "primary",
"preferred_contact_method": "primary",
"first_name": "primary",
"last_name": "primary",
"phone": "primary",
"phone_e164": "primary",
"street": "primary",
"address_line2": "primary",
"city": "primary",
"state": "primary",
"zip": "primary",
"country": "primary",
"country_code": "primary",
"subdivision_code": "primary",
"can_receive_sms": "primary",
"assigned_fundraiser_user_id": "primary"
},
"plan_impact_version": "issued-plan-impact-version",
"plan_repairs": [
{
"plan_id": 42,
"action": "archive_plan",
"action_donor_id": 42,
"reason": "Preserving the surviving donor plan."
}
]
}
'import requests
url = "https://api.gratona.com/v1/admin/donors/duplicates/manual-merge"
payload = {
"review_id": "550e8400-e29b-41d4-a716-446655440000",
"confirmed_same_person": True,
"reason": "Verified duplicate donor records.",
"field_choices": {
"username": "primary",
"email": "primary",
"type": "primary",
"organization_name": "primary",
"preferred_contact_method": "primary",
"first_name": "primary",
"last_name": "primary",
"phone": "primary",
"phone_e164": "primary",
"street": "primary",
"address_line2": "primary",
"city": "primary",
"state": "primary",
"zip": "primary",
"country": "primary",
"country_code": "primary",
"subdivision_code": "primary",
"can_receive_sms": "primary",
"assigned_fundraiser_user_id": "primary"
},
"plan_impact_version": "issued-plan-impact-version",
"plan_repairs": [
{
"plan_id": 42,
"action": "archive_plan",
"action_donor_id": 42,
"reason": "Preserving the surviving donor plan."
}
]
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
review_id: '550e8400-e29b-41d4-a716-446655440000',
confirmed_same_person: true,
reason: 'Verified duplicate donor records.',
field_choices: {
username: 'primary',
email: 'primary',
type: 'primary',
organization_name: 'primary',
preferred_contact_method: 'primary',
first_name: 'primary',
last_name: 'primary',
phone: 'primary',
phone_e164: 'primary',
street: 'primary',
address_line2: 'primary',
city: 'primary',
state: 'primary',
zip: 'primary',
country: 'primary',
country_code: 'primary',
subdivision_code: 'primary',
can_receive_sms: 'primary',
assigned_fundraiser_user_id: 'primary'
},
plan_impact_version: 'issued-plan-impact-version',
plan_repairs: [
{
plan_id: 42,
action: 'archive_plan',
action_donor_id: 42,
reason: 'Preserving the surviving donor plan.'
}
]
})
};
fetch('https://api.gratona.com/v1/admin/donors/duplicates/manual-merge', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.gratona.com/v1/admin/donors/duplicates/manual-merge",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'review_id' => '550e8400-e29b-41d4-a716-446655440000',
'confirmed_same_person' => true,
'reason' => 'Verified duplicate donor records.',
'field_choices' => [
'username' => 'primary',
'email' => 'primary',
'type' => 'primary',
'organization_name' => 'primary',
'preferred_contact_method' => 'primary',
'first_name' => 'primary',
'last_name' => 'primary',
'phone' => 'primary',
'phone_e164' => 'primary',
'street' => 'primary',
'address_line2' => 'primary',
'city' => 'primary',
'state' => 'primary',
'zip' => 'primary',
'country' => 'primary',
'country_code' => 'primary',
'subdivision_code' => 'primary',
'can_receive_sms' => 'primary',
'assigned_fundraiser_user_id' => 'primary'
],
'plan_impact_version' => 'issued-plan-impact-version',
'plan_repairs' => [
[
'plan_id' => 42,
'action' => 'archive_plan',
'action_donor_id' => 42,
'reason' => 'Preserving the surviving donor plan.'
]
]
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://api.gratona.com/v1/admin/donors/duplicates/manual-merge"
payload := strings.NewReader("{\n \"review_id\": \"550e8400-e29b-41d4-a716-446655440000\",\n \"confirmed_same_person\": true,\n \"reason\": \"Verified duplicate donor records.\",\n \"field_choices\": {\n \"username\": \"primary\",\n \"email\": \"primary\",\n \"type\": \"primary\",\n \"organization_name\": \"primary\",\n \"preferred_contact_method\": \"primary\",\n \"first_name\": \"primary\",\n \"last_name\": \"primary\",\n \"phone\": \"primary\",\n \"phone_e164\": \"primary\",\n \"street\": \"primary\",\n \"address_line2\": \"primary\",\n \"city\": \"primary\",\n \"state\": \"primary\",\n \"zip\": \"primary\",\n \"country\": \"primary\",\n \"country_code\": \"primary\",\n \"subdivision_code\": \"primary\",\n \"can_receive_sms\": \"primary\",\n \"assigned_fundraiser_user_id\": \"primary\"\n },\n \"plan_impact_version\": \"issued-plan-impact-version\",\n \"plan_repairs\": [\n {\n \"plan_id\": 42,\n \"action\": \"archive_plan\",\n \"action_donor_id\": 42,\n \"reason\": \"Preserving the surviving donor plan.\"\n }\n ]\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://api.gratona.com/v1/admin/donors/duplicates/manual-merge")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"review_id\": \"550e8400-e29b-41d4-a716-446655440000\",\n \"confirmed_same_person\": true,\n \"reason\": \"Verified duplicate donor records.\",\n \"field_choices\": {\n \"username\": \"primary\",\n \"email\": \"primary\",\n \"type\": \"primary\",\n \"organization_name\": \"primary\",\n \"preferred_contact_method\": \"primary\",\n \"first_name\": \"primary\",\n \"last_name\": \"primary\",\n \"phone\": \"primary\",\n \"phone_e164\": \"primary\",\n \"street\": \"primary\",\n \"address_line2\": \"primary\",\n \"city\": \"primary\",\n \"state\": \"primary\",\n \"zip\": \"primary\",\n \"country\": \"primary\",\n \"country_code\": \"primary\",\n \"subdivision_code\": \"primary\",\n \"can_receive_sms\": \"primary\",\n \"assigned_fundraiser_user_id\": \"primary\"\n },\n \"plan_impact_version\": \"issued-plan-impact-version\",\n \"plan_repairs\": [\n {\n \"plan_id\": 42,\n \"action\": \"archive_plan\",\n \"action_donor_id\": 42,\n \"reason\": \"Preserving the surviving donor plan.\"\n }\n ]\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://api.gratona.com/v1/admin/donors/duplicates/manual-merge")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"review_id\": \"550e8400-e29b-41d4-a716-446655440000\",\n \"confirmed_same_person\": true,\n \"reason\": \"Verified duplicate donor records.\",\n \"field_choices\": {\n \"username\": \"primary\",\n \"email\": \"primary\",\n \"type\": \"primary\",\n \"organization_name\": \"primary\",\n \"preferred_contact_method\": \"primary\",\n \"first_name\": \"primary\",\n \"last_name\": \"primary\",\n \"phone\": \"primary\",\n \"phone_e164\": \"primary\",\n \"street\": \"primary\",\n \"address_line2\": \"primary\",\n \"city\": \"primary\",\n \"state\": \"primary\",\n \"zip\": \"primary\",\n \"country\": \"primary\",\n \"country_code\": \"primary\",\n \"subdivision_code\": \"primary\",\n \"can_receive_sms\": \"primary\",\n \"assigned_fundraiser_user_id\": \"primary\"\n },\n \"plan_impact_version\": \"issued-plan-impact-version\",\n \"plan_repairs\": [\n {\n \"plan_id\": 42,\n \"action\": \"archive_plan\",\n \"action_donor_id\": 42,\n \"reason\": \"Preserving the surviving donor plan.\"\n }\n ]\n}"
response = http.request(request)
puts response.read_body{
"success": true,
"batch_id": 42,
"data": {
"batch_id": 42,
"merges_count": 1
}
}{
"message": "Something went wrong. Please try again.",
"status": "error",
"error": "invalid_request",
"code": "DONOR_NOT_FOUND"
}{
"message": "Something went wrong. Please try again.",
"status": "error",
"error": "invalid_request",
"code": "DONOR_NOT_FOUND"
}{
"message": "Not Found",
"status": "error"
}{
"success": false,
"code": "MANUAL_REVIEW_ALREADY_CONFIRMED",
"message": "Review the selected records again.",
"data": {
"batch_id": 42
},
"batch_id": 42
}{
"success": false,
"message": "Resolve listed dependencies before merging.",
"blockers": [
{
"code": "integration_identity_conflict",
"message": "Review connected identities before merging.",
"donor_id": 42,
"provider_key": "quickbooks",
"connection_id": 42,
"provider_object_type": "customer",
"identities": [
{
"donor_id": 42,
"provider_object_id": "customer-123"
}
],
"conflicts": [
{}
]
}
],
"errors": {}
}Authorizations
Passport bearer token authentication for legacy admin sessions.
Body
Unexpired actor-owned review UUID.
"550e8400-e29b-41d4-a716-446655440000"
Must be accepted to confirm same identity.
true
Reason is trimmed before validation.
10 - 2000"Verified duplicate donor records."
Optional explicit safe-field winners; other profile fields follow merge defaults.
Show child attributes
Show child attributes
Signed five-minute token from a 409 impact response, required when open plans are materially affected.
4096"issued-plan-impact-version"
50Show child attributes
Show child attributes
curl --request POST \
--url https://api.gratona.com/v1/admin/donors/duplicates/manual-merge \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"review_id": "550e8400-e29b-41d4-a716-446655440000",
"confirmed_same_person": true,
"reason": "Verified duplicate donor records.",
"field_choices": {
"username": "primary",
"email": "primary",
"type": "primary",
"organization_name": "primary",
"preferred_contact_method": "primary",
"first_name": "primary",
"last_name": "primary",
"phone": "primary",
"phone_e164": "primary",
"street": "primary",
"address_line2": "primary",
"city": "primary",
"state": "primary",
"zip": "primary",
"country": "primary",
"country_code": "primary",
"subdivision_code": "primary",
"can_receive_sms": "primary",
"assigned_fundraiser_user_id": "primary"
},
"plan_impact_version": "issued-plan-impact-version",
"plan_repairs": [
{
"plan_id": 42,
"action": "archive_plan",
"action_donor_id": 42,
"reason": "Preserving the surviving donor plan."
}
]
}
'import requests
url = "https://api.gratona.com/v1/admin/donors/duplicates/manual-merge"
payload = {
"review_id": "550e8400-e29b-41d4-a716-446655440000",
"confirmed_same_person": True,
"reason": "Verified duplicate donor records.",
"field_choices": {
"username": "primary",
"email": "primary",
"type": "primary",
"organization_name": "primary",
"preferred_contact_method": "primary",
"first_name": "primary",
"last_name": "primary",
"phone": "primary",
"phone_e164": "primary",
"street": "primary",
"address_line2": "primary",
"city": "primary",
"state": "primary",
"zip": "primary",
"country": "primary",
"country_code": "primary",
"subdivision_code": "primary",
"can_receive_sms": "primary",
"assigned_fundraiser_user_id": "primary"
},
"plan_impact_version": "issued-plan-impact-version",
"plan_repairs": [
{
"plan_id": 42,
"action": "archive_plan",
"action_donor_id": 42,
"reason": "Preserving the surviving donor plan."
}
]
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
review_id: '550e8400-e29b-41d4-a716-446655440000',
confirmed_same_person: true,
reason: 'Verified duplicate donor records.',
field_choices: {
username: 'primary',
email: 'primary',
type: 'primary',
organization_name: 'primary',
preferred_contact_method: 'primary',
first_name: 'primary',
last_name: 'primary',
phone: 'primary',
phone_e164: 'primary',
street: 'primary',
address_line2: 'primary',
city: 'primary',
state: 'primary',
zip: 'primary',
country: 'primary',
country_code: 'primary',
subdivision_code: 'primary',
can_receive_sms: 'primary',
assigned_fundraiser_user_id: 'primary'
},
plan_impact_version: 'issued-plan-impact-version',
plan_repairs: [
{
plan_id: 42,
action: 'archive_plan',
action_donor_id: 42,
reason: 'Preserving the surviving donor plan.'
}
]
})
};
fetch('https://api.gratona.com/v1/admin/donors/duplicates/manual-merge', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.gratona.com/v1/admin/donors/duplicates/manual-merge",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'review_id' => '550e8400-e29b-41d4-a716-446655440000',
'confirmed_same_person' => true,
'reason' => 'Verified duplicate donor records.',
'field_choices' => [
'username' => 'primary',
'email' => 'primary',
'type' => 'primary',
'organization_name' => 'primary',
'preferred_contact_method' => 'primary',
'first_name' => 'primary',
'last_name' => 'primary',
'phone' => 'primary',
'phone_e164' => 'primary',
'street' => 'primary',
'address_line2' => 'primary',
'city' => 'primary',
'state' => 'primary',
'zip' => 'primary',
'country' => 'primary',
'country_code' => 'primary',
'subdivision_code' => 'primary',
'can_receive_sms' => 'primary',
'assigned_fundraiser_user_id' => 'primary'
],
'plan_impact_version' => 'issued-plan-impact-version',
'plan_repairs' => [
[
'plan_id' => 42,
'action' => 'archive_plan',
'action_donor_id' => 42,
'reason' => 'Preserving the surviving donor plan.'
]
]
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://api.gratona.com/v1/admin/donors/duplicates/manual-merge"
payload := strings.NewReader("{\n \"review_id\": \"550e8400-e29b-41d4-a716-446655440000\",\n \"confirmed_same_person\": true,\n \"reason\": \"Verified duplicate donor records.\",\n \"field_choices\": {\n \"username\": \"primary\",\n \"email\": \"primary\",\n \"type\": \"primary\",\n \"organization_name\": \"primary\",\n \"preferred_contact_method\": \"primary\",\n \"first_name\": \"primary\",\n \"last_name\": \"primary\",\n \"phone\": \"primary\",\n \"phone_e164\": \"primary\",\n \"street\": \"primary\",\n \"address_line2\": \"primary\",\n \"city\": \"primary\",\n \"state\": \"primary\",\n \"zip\": \"primary\",\n \"country\": \"primary\",\n \"country_code\": \"primary\",\n \"subdivision_code\": \"primary\",\n \"can_receive_sms\": \"primary\",\n \"assigned_fundraiser_user_id\": \"primary\"\n },\n \"plan_impact_version\": \"issued-plan-impact-version\",\n \"plan_repairs\": [\n {\n \"plan_id\": 42,\n \"action\": \"archive_plan\",\n \"action_donor_id\": 42,\n \"reason\": \"Preserving the surviving donor plan.\"\n }\n ]\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://api.gratona.com/v1/admin/donors/duplicates/manual-merge")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"review_id\": \"550e8400-e29b-41d4-a716-446655440000\",\n \"confirmed_same_person\": true,\n \"reason\": \"Verified duplicate donor records.\",\n \"field_choices\": {\n \"username\": \"primary\",\n \"email\": \"primary\",\n \"type\": \"primary\",\n \"organization_name\": \"primary\",\n \"preferred_contact_method\": \"primary\",\n \"first_name\": \"primary\",\n \"last_name\": \"primary\",\n \"phone\": \"primary\",\n \"phone_e164\": \"primary\",\n \"street\": \"primary\",\n \"address_line2\": \"primary\",\n \"city\": \"primary\",\n \"state\": \"primary\",\n \"zip\": \"primary\",\n \"country\": \"primary\",\n \"country_code\": \"primary\",\n \"subdivision_code\": \"primary\",\n \"can_receive_sms\": \"primary\",\n \"assigned_fundraiser_user_id\": \"primary\"\n },\n \"plan_impact_version\": \"issued-plan-impact-version\",\n \"plan_repairs\": [\n {\n \"plan_id\": 42,\n \"action\": \"archive_plan\",\n \"action_donor_id\": 42,\n \"reason\": \"Preserving the surviving donor plan.\"\n }\n ]\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://api.gratona.com/v1/admin/donors/duplicates/manual-merge")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"review_id\": \"550e8400-e29b-41d4-a716-446655440000\",\n \"confirmed_same_person\": true,\n \"reason\": \"Verified duplicate donor records.\",\n \"field_choices\": {\n \"username\": \"primary\",\n \"email\": \"primary\",\n \"type\": \"primary\",\n \"organization_name\": \"primary\",\n \"preferred_contact_method\": \"primary\",\n \"first_name\": \"primary\",\n \"last_name\": \"primary\",\n \"phone\": \"primary\",\n \"phone_e164\": \"primary\",\n \"street\": \"primary\",\n \"address_line2\": \"primary\",\n \"city\": \"primary\",\n \"state\": \"primary\",\n \"zip\": \"primary\",\n \"country\": \"primary\",\n \"country_code\": \"primary\",\n \"subdivision_code\": \"primary\",\n \"can_receive_sms\": \"primary\",\n \"assigned_fundraiser_user_id\": \"primary\"\n },\n \"plan_impact_version\": \"issued-plan-impact-version\",\n \"plan_repairs\": [\n {\n \"plan_id\": 42,\n \"action\": \"archive_plan\",\n \"action_donor_id\": 42,\n \"reason\": \"Preserving the surviving donor plan.\"\n }\n ]\n}"
response = http.request(request)
puts response.read_body{
"success": true,
"batch_id": 42,
"data": {
"batch_id": 42,
"merges_count": 1
}
}{
"message": "Something went wrong. Please try again.",
"status": "error",
"error": "invalid_request",
"code": "DONOR_NOT_FOUND"
}{
"message": "Something went wrong. Please try again.",
"status": "error",
"error": "invalid_request",
"code": "DONOR_NOT_FOUND"
}{
"message": "Not Found",
"status": "error"
}{
"success": false,
"code": "MANUAL_REVIEW_ALREADY_CONFIRMED",
"message": "Review the selected records again.",
"data": {
"batch_id": 42
},
"batch_id": 42
}{
"success": false,
"message": "Resolve listed dependencies before merging.",
"blockers": [
{
"code": "integration_identity_conflict",
"message": "Review connected identities before merging.",
"donor_id": 42,
"provider_key": "quickbooks",
"connection_id": 42,
"provider_object_type": "customer",
"identities": [
{
"donor_id": 42,
"provider_object_id": "customer-123"
}
],
"conflicts": [
{}
]
}
],
"errors": {}
}